TYPOS.Flow - Bug # 8432

Status: Resolved Priority: Must have
Author: Bastian Waidelich Category: Resource
Created: 2010-06-22 Assigned To: Bastian Waidelich
Updated: 2010-10-20 Due date:

PHP Version:

Has patch:

Complexity:

Affected Flow version:

Subject: Fix Symlink support for Windows OS

Description

With version 5.3 PHP supports symlinks on Windows >= Vista.

symlink($target, $link) works indeed on my Windows 7 machine. But is_link($link) returns FALSE.

That's why the unit test
F3\FLOW3\Resource\Publishing\FileSystemPublishingTargetTest::mirrorFileSymLinksTheGivenFilelfTheSettingSaysSo()

fails on Windows.

A solution might be to use readlink() instead of is_link() as readlink() returns the same for $target and $link (the path to the target)..

Related issues:
related to TYPOS.Flow - Task # 8056: Remove configuration option for mirrorMode Closed

Associated revisions

Revision 56b6ac99 - 2010-07-15 14:20 - Bastian Waidelich

[+BUGFIX] FLOW3: Added helper function \F3\FLOW3\Utility\Files::is_link() that works on Windows too. This resolves #8432.

History

#1 - 2010-06-25 15:00 - Karsten Dambekalns
- Status changed from New to Needs Feedback

- Assigned To set to Karsten Dambekalns

From the PHP manual about readlink():
This will trigger a warning and return false if you pass it a non-symlink.

This is something we don't want, no warnings please. So we'd have to check for the OS as well.

Given that what we see is a bug in PHP...
http://bugs.php.net/bug.php?id=52175
http://bugs.php.net/bug.php?id=51766
wait until they fix it?

#2 - 2010-07-15 13:15 - Bastian Waidelich
- Status changed from Needs Feedback to Accepted
- Assigned To changed from Karsten Dambekalns to Bastian Waidelich
http://bugs.php.net/bug.php?id=52175
http://bugs.php.net/bug.php?id=51766

After a short chat with Karsten, we found out:

readlink() does not trigger a warning on Windows as long as you pass it a path to an existing file/folder or symlink.

Because the symlink integration is implemented very deep in the Windows filesystem, | doubt that PHP will be able to fix this issue soon. So we
decided to add a new utility helper function F3\FLOWS3\Utility\Files::is_link() that uses the readlink() workaround on Windows.

#3 - 2010-07-15 14:21 - Bastian Waidelich
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r4862.

#4 - 2010-07-19 08:01 - Karsten Dambekalns

- Target version set to 1.0 alpha 11
